#!/usr/local/bin/tksipp
#
# Small Tk program to render and display an image.  It then must be screen
# dumped by hand.  Use `-misc big' argument to generate an large image and
# large button fonts. Add -final to generate final image.  Best dumped with
# xv, not xwd.  Save as `tk_window.ppm' in PPM format.
#
# $Id: tkimage.tcl,v 1.4 1997/07/20 21:43:37 markd Exp $
#

source ../utils.tcl
source ../compound_objects/mbrick_procs.tcl

ParseArgs

if {[lsearch $misc big] >= 0} {
    set size 650
    set buttonFont {-Adobe-Helvetica-Bold-R-Normal--*-240-*-*-*-*-*-*}
} else {
    set buttonFont {-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*}
}
set dump [expr [lsearch $misc dump] >= 0]
set outfile tk_window.xwd

SippLightSourceCreate {15.0 15.0 15.0} {0.9 0.9 0.9} POINT
SippCameraParams STDCAMERA {-4.0 4.0 10.0} {0.0 0.0 0.0} {0.0 1.0 0.0} 0.4
SippObjectAddSubobj WORLD [MBrick $final]
SippShowBackFaces $backfaces

proc DoRender {} {
    global photoImg size mode final dump outfile
    .buttons.render configure -state disabled
    .buttons.abort configure -state normal
    SippRender $photoImg $size $size $mode [expr $final ? 3 : 1]
    .buttons.abort configure -state disabled
    .buttons.render configure -state normal
}

set photoImg [image create photo -height $size -width $size]
label .photo -image $photoImg -background [SippColor tox {0 0 0}]

frame .buttons
button .buttons.render -text Render -command DoRender -font $buttonFont
button .buttons.abort -text Abort -command SippAbortRender -state disabled \
        -font $buttonFont
button .buttons.exit -text Exit -command {exit} -font $buttonFont

pack .photo -expand 1
pack .buttons -expand 1
pack .buttons.render -side left -expand 1
pack .buttons.abort -side left -expand 1
pack .buttons.exit -side left -expand 1
